/**
 * name: use-spotlight@1.0.8
 * desc: A react hook that generates a animated 'spotlight' follows the active target.
 * author: 9am <tech.9am@gmail.com> [https://9am.github.io/]
 * homepage: https://github.com/9am/use-spotlight#readme
 * license: MIT
 */
import { useState as C, useRef as L, useCallback as M, useEffect as z } from "react";
var j = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function A(t) {
  return t && t.__esModule && Object.prototype.hasOwnProperty.call(t, "default") ? t.default : t;
}
var _ = "Expected a function", $ = 0 / 0, D = "[object Symbol]", F = /^\s+|\s+$/g, G = /^[-+]0x[0-9a-f]+$/i, V = /^0b[01]+$/i, H = /^0o[0-7]+$/i, U = parseInt, X = typeof j == "object" && j && j.Object === Object && j, q = typeof self == "object" && self && self.Object === Object && self, J = X || q || Function("return this")(), K = Object.prototype, Q = K.toString, Y = Math.max, Z = Math.min, E = function() {
  return J.Date.now();
};
function tt(t, r, e) {
  var i, s, u, c, a, l, d = 0, m = !1, p = !1, v = !0;
  if (typeof t != "function")
    throw new TypeError(_);
  r = B(r) || 0, O(e) && (m = !!e.leading, p = "maxWait" in e, u = p ? Y(B(e.maxWait) || 0, r) : u, v = "trailing" in e ? !!e.trailing : v);
  function x(n) {
    var h = i, R = s;
    return i = s = void 0, d = n, c = t.apply(R, h), c;
  }
  function o(n) {
    return d = n, a = setTimeout(f, r), m ? x(n) : c;
  }
  function b(n) {
    var h = n - l, R = n - d, I = r - h;
    return p ? Z(I, u - R) : I;
  }
  function g(n) {
    var h = n - l, R = n - d;
    return l === void 0 || h >= r || h < 0 || p && R >= u;
  }
  function f() {
    var n = E();
    if (g(n))
      return S(n);
    a = setTimeout(f, b(n));
  }
  function S(n) {
    return a = void 0, v && i ? x(n) : (i = s = void 0, c);
  }
  function w() {
    a !== void 0 && clearTimeout(a), d = 0, i = l = s = a = void 0;
  }
  function k() {
    return a === void 0 ? c : S(E());
  }
  function y() {
    var n = E(), h = g(n);
    if (i = arguments, s = this, l = n, h) {
      if (a === void 0)
        return o(l);
      if (p)
        return a = setTimeout(f, r), x(l);
    }
    return a === void 0 && (a = setTimeout(f, r)), c;
  }
  return y.cancel = w, y.flush = k, y;
}
function et(t, r, e) {
  var i = !0, s = !0;
  if (typeof t != "function")
    throw new TypeError(_);
  return O(e) && (i = "leading" in e ? !!e.leading : i, s = "trailing" in e ? !!e.trailing : s), tt(t, r, {
    leading: i,
    maxWait: r,
    trailing: s
  });
}
function O(t) {
  var r = typeof t;
  return !!t && (r == "object" || r == "function");
}
function rt(t) {
  return !!t && typeof t == "object";
}
function nt(t) {
  return typeof t == "symbol" || rt(t) && Q.call(t) == D;
}
function B(t) {
  if (typeof t == "number")
    return t;
  if (nt(t))
    return $;
  if (O(t)) {
    var r = typeof t.valueOf == "function" ? t.valueOf() : t;
    t = O(r) ? r + "" : r;
  }
  if (typeof t != "string")
    return t === 0 ? t : +t;
  t = t.replace(F, "");
  var e = V.test(t);
  return e || H.test(t) ? U(t.slice(2), e ? 2 : 8) : G.test(t) ? $ : +t;
}
var it = et;
const ot = /* @__PURE__ */ A(it), st = {
  throttleWait: 0,
  stageBorderEdge: !1,
  stageMutation: !1
}, W = [0, 0, 0, 0], T = { x: 0, y: 0, width: 0, height: 0 }, N = (t, r) => {
  var e;
  try {
    return +(((e = getComputedStyle(t, null)) == null ? void 0 : e.getPropertyValue(r)) ?? "").replace("px", "");
  } catch {
    return 0;
  }
}, P = (t, r) => {
  const e = (t == null ? void 0 : t.getBoundingClientRect()) ?? T, i = r ? N(t, "border-left-width") : 0, s = r ? N(t, "border-top-width") : 0;
  return {
    ...e,
    x: e.x - ((t == null ? void 0 : t.scrollLeft) ?? 0) + i,
    y: e.y - ((t == null ? void 0 : t.scrollTop) ?? 0) + s
  };
}, at = ([t, r, e, i]) => ({
  "--spotlight-x": `${t}px`,
  "--spotlight-y": `${r}px`,
  "--spotlight-w": `${e}px`,
  "--spotlight-h": `${i}px`,
  "--spotlight-duration": "200ms",
  "--spotlight-bg": "rgba(255, 0, 0, 0.1)",
  content: '""',
  display: "block",
  boxSizing: "border-box",
  position: "absolute",
  top: "0px",
  left: "0px",
  width: "var(--spotlight-w)",
  height: "var(--spotlight-h)",
  transform: "translate(var(--spotlight-x), var(--spotlight-y))",
  transitionProperty: "transform, width, height",
  transitionDuration: "var(--spotlight-duration)",
  background: "var(--spotlight-bg)",
  pointerEvents: "none",
  zIndex: "999",
  padding: "0px",
  margin: "0px",
  overflow: "hidden"
}), ct = (t) => {
  const { throttleWait: r, stageBorderEdge: e, stageMutation: i } = {
    ...st,
    ...t
  }, [s, u] = C(W), [c, a] = C(T), [l, d] = C(T);
  let m = L(null), p = L(null);
  const v = M(
    (o) => {
      m.current = o, a(o ? P(o, e) : T);
    },
    [a, e]
  ), x = M(
    (o) => {
      p.current = o, d((o == null ? void 0 : o.getBoundingClientRect()) ?? T);
    },
    [d]
  );
  return z(() => {
    u([
      l.x - c.x,
      l.y - c.y,
      l.width,
      l.height
    ]);
  }, [c, l, u]), z(() => {
    const o = m.current, b = p.current;
    if (!o || !b)
      return () => u(W);
    let g = null, f = null;
    const S = ot(() => {
      const y = P(o, e), n = b.getBoundingClientRect();
      u([n.x - y.x, n.y - y.y, n.width, n.height]);
    }, r), w = () => {
      S();
    };
    typeof ResizeObserver < "u" && (g = new ResizeObserver(S), g.observe(o), g.observe(b)), typeof MutationObserver < "u" && (f = new MutationObserver(w), i && f.observe(o, {
      subtree: !0,
      childList: !0
    }), f.observe(b, {
      subtree: !0,
      childList: !0,
      characterData: !0
    }));
    const k = o.style.position;
    return o.style.position = "relative", () => {
      o.style.position = k, g == null || g.disconnect(), f == null || f.disconnect();
    };
  }, [c, l, u, r, e, i]), {
    stage: v,
    actor: x,
    style: at(s),
    size: s
  };
}, ft = null;
export {
  ft as default,
  ct as useSpotlight
};
