import type { RefCallback } from 'react';

declare const _default: null;
export default _default;

export declare type Rect = {
    x: number;
    y: number;
    width: number;
    height: number;
};

export declare type Size = [number, number, number, number];

export declare type Spotlight = {
    stage: RefCallback<any>;
    actor: RefCallback<any>;
    style: {
        [key: string]: string;
    };
    size: Size;
};

export declare type SpotlightOptions = {
    throttleWait?: number;
    stageBorderEdge?: boolean;
    stageMutation?: boolean;
};

export declare const useSpotlight: (options?: SpotlightOptions) => Spotlight;

export { }
